MODULE CDTest;

FROM OLib IMPORT  IsCdRom, GetDriveCount, FirstCdRom, CDCopyrightName, CDAbstrName, CDBibName,CDGetDrvList,CDReadVTOC,GetCDDrives,OpenCDHandle;
FROM Lib IMPORT Fill;
IMPORT IO,FIO;
TYPE DevRec = RECORD
               SubUnit : BYTE;
               AddrOfs : CARDINAL;
               AddrSeg : CARDINAL;
               END;
 TDevPoint=POINTER TO TDevHeader;
 TDevHeader=RECORD
             Next:TDevPoint;
             Attr:CARDINAL;
             Strat:CARDINAL;
             Intr:CARDINAL;
             Name:ARRAY[0..7] OF CHAR;
             END;

 StrPtr=POINTER TO ARRAY[0..7] OF CHAR;

VAR O:ARRAY[0..100] OF CHAR;
    A:BOOLEAN;
    D:CARDINAL;
    K : ARRAY[0..50] OF DevRec;
    L : ARRAY[0..2047] OF BYTE;
    TP : TDevPoint;
    QQ : FIO.File;


BEGIN
 IO.WrStr("Drive F is ");
 IF IsCdRom("f")=0 THEN
  IO.WrStr("no");
 ELSE
  IO.WrChar ("a");
  END;
 IO.WrStr(" cdrom"); IO.WrLn;
 IO.WrStr("Nr. of cdrom drives : ");IO.WrCard(GetDriveCount(),-5);    IO.WrLn;
 IO.WrStr("First cdrom         : ");IO.WrChar(CHR(64+FirstCdRom()));  IO.WrLn;
 A:=CDCopyrightName(7,O);

 IF A THEN
  IO.WrStr("CD-copyrightname      : ");  IO.WrStr(O);  IO.WrLn;
  IO.WrStr("CD-Abstractname       : ");
  A:=CDAbstrName(6,O);     IO.WrStr(O); IO.WrLn;
  IO.WrStr("CD-Bibnam             : ");
  A:=CDBibName(6,O);       IO.WrStr(O); IO.WrLn;
  END;
(*
 CDGetDrvList(K);
 FOR D:=0 TO  NrCdRoms()-1 DO
(*   IO.WrCard(CARDINAL(K[D].SubUnit),-5); *)
   TP:=[K[D].AddrSeg:K[D].AddrOfs];
   IO.WrStr(TP^.Name);
   END; *)
 QQ:=OpenCDHandle();
 IO.WrCard(QQ,5);
 HALT;
 CDReadVTOC(6,L);
 Fill(ADR(L),100,0);
 GetCDDrives(L);
 FOR D:=0 TO 10 DO
  IF (L[D]#BYTE(0)) OR (D=0) THEN
   IO.WrChar(CHR(BYTE(65)+BYTE(L[D])));
   END;
  END;
END CDTest.