MODULE HelpDemo;
(* A helpfile browser XTDLIB package (C) 1997 by Marco van de Voort,
 demonstrates HelpSystem.

This is a very elementary helpfile browser, meant for checking an helpfile,
or for people without the TopSpeed environment, or without the parts that
enable using foreign .HTX files. It assumes a helpfile compiled with HELPCOMP
as argument, and initialises on the first item. If you can't access all
items via the main(and sub) menus, you can't see them with this program.

Do not run this in small or medium memorymodel, HelpSystem requires too much
    dynamic memory*)

FROM Lib IMPORT ParamCount,ParamStr,EnableBreakCheck;
IMPORT HelpSystem,IO;

VAR  S   : ARRAY[0..100] OF CHAR;
     Hlp : HelpSystem.HlpHandle;
     A   : CARDINAL;

(*68 x 21 *)

BEGIN
  IO.WrStr(S);                           (* Avoids a HeapFarAllocate!?*)
 IF ParamCount()<1 THEN
  HALT;
  END;
 ParamStr(S,1);
 EnableBreakCheck;
 HelpSystem.Col:=HelpSystem.JPICols;
 Hlp:=HelpSystem.InitHelpFile(S);

 A:=HelpSystem.MainHelpFunc(Hlp,0);
 HelpSystem.RemoveHelpFile(Hlp);
END HelpDemo.