MODULE SetFont;
(* Demo belonging to CoreFont(XtdLib package), (C) by Marco van de Voort 1996
   VGA/EGA only!!

   Loads *.FT font specified on commandline, and make it active.
   *)

FROM CoreFont IMPORT GetSetFont,FontP;
FROM Lib      IMPORT ParamStr,ParamCount;
FROM Storage  IMPORT ALLOCATE;
FROM Str      IMPORT Append;

IMPORT FIO,IO;

VAR Fnt         : FontP;
    F           : FIO.File;
    S           : ARRAY[0..255] OF CHAR;
    BytesRead   : CARDINAL;


BEGIN
 IF ParamCount()=0 THEN
  IO.WrStr("Usage : SetFont Filename[.FT]");
  IO.WrLn;
  IO.WrLn;
  HALT;
  END;
 ParamStr(S,1);
 IF NOT FIO.Exists(S) THEN
  Append(S,".FT");
  IF NOT FIO.Exists(S) THEN
   IO.WrStr("SetFont : Font not found");
   IO.WrLn;
   HALT;
   END;
  END;
 NEW(Fnt);
 F:=FIO.Open(S);
 BytesRead:=FIO.RdBin(F,Fnt^,4);
 BytesRead:=FIO.RdBin(F,Fnt^,4096);
 FIO.Close(F);
 GetSetFont(255*256,0,Fnt^,TRUE); (* Activate font *)
END SetFont.