MODULE ShowAnsi;
(*
Demo ANSI support Crt (XtdLib package), (C) by Marco van de Voort 1996
   VGA only!!. (Crt requires it)

Shows ansi-file on commandline without ANSI-driver loaded.

The following information is data I use to determine a very small bug.
TwHello.ans goes wrong on Debug=876

*)

FROM IO IMPORT WrStr,WrLn;
FROM Str  IMPORT CHARSET;
IMPORT Crt;
FROM Lib IMPORT ParamStr,ParamCount;

IMPORT FIO;

VAR F  : FIO.File;
    B  : ARRAY[0..1000] OF BYTE;
    S  : ARRAY[0..25] OF CHAR;
    A  : CARDINAL;
    C  : CHAR;

    Debug : CARDINAL; (* Dummy variable, for use with VID, remove if you wish*)

CONST Trigger=CHARSET{"H","f","A".."D","s","u","J","K","m"};

BEGIN
 IF ParamCount()<1 THEN
  HALT;
  END;
 ParamStr(S,1);
 IF NOT FIO.Exists(S) THEN
  WrStr("File not available");
  HALT;
  END;
 Crt.TextColor(Crt.LightGray);
 Crt.GotoXY(0,0);
 Crt.TrapAnsi:=TRUE;
 F:=FIO.Open(S);
 FIO.AssignBuffer(F,B);
 A:=0;
 Debug:=0;
 LOOP
   C:=FIO.RdChar(F);
   IF FIO.EOF THEN
    EXIT
    END;
   IF C=CHR(27) THEN
    S[0]:=CHR(27);
    A:=1;
    LOOP
     C:=FIO.RdChar(F);
     IF FIO.EOF THEN
      S[A+1]:=CHR(0);
      A:=1000;
      EXIT
      END;
     S[A]:=C;
     IF (C IN Trigger) OR (A>23) THEN
      S[A+1]:=CHR(0);
      EXIT
      END;
     INC(A);
     END;
    INC(Debug);
    WrStr(S);
    IF A=1000 THEN
     EXIT
     END;
   ELSE
    WrStr(C);
    END;
  END;
 FIO.Close(F);
END ShowAnsi.